Bug 114017 - I18N - provide properties/options to change ide global font name and font size
I18N - provide properties/options to change ide global font name and font size
Status: NEW
Product: java
Classification: Unclassified
Component: Editor
6.x
PC Windows Vista
: P2 with 2 votes (vote)
: 6.x
Assigned To: Dusan Balek
issues@java
: A11Y, I18N, UI, USABILITY
: 101740 116676 125083 (view as bug list)
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2007-08-28 15:19 UTC by Ken Frank
Modified: 2010-12-20 12:39 UTC (History)
6 users (show)

See Also:
Issue Type: ENHANCEMENT
:


Attachments
nb60_vs_windows image (17.67 KB, application/octet-stream)
2007-10-26 06:21 UTC, Rebecca Liu
Details
ide image (13.31 KB, image/png)
2007-10-26 06:23 UTC, Rebecca Liu
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Ken Frank 2007-08-28 15:19:38 UTC
Users in Chinese locale are starting to request to have a property/option to be able to change
the global ide font (not just users of localized product, but those who don't want to use localized)

Of course this could help any user.

The reason for Chinese is that the default ide fonts do not always display well for Chinese on some platforms.

For the editor, there is issue 113691, requesting an easier way to change the editor font than needing
to go into the editor font options and do those steps, since its not as clear as having one editor font option.

But there is no current option for changing ide global font and yet the same font quality situation
exists for Chinese users.

** I wonder if this could be considered being changed to an issue or task rather than enhancement since it does seem
like its an actual problem that needs solving for some users.
Comment 1 Ken Frank 2007-08-28 15:22:38 UTC
wzhang and rethe - please add comments and if you can ask other users in China who have commented
about needing this feature to add their comments, it can help the nb team.

ken.frank@sun.com
Comment 2 rehte 2007-08-29 04:20:27 UTC
kfrank,

I've posted the request message on some forums asking Chinese developers to comment here.
I've also posted the request on my blogs. I hope more people can come here and contribute their ideas.
Comment 3 diggywang 2007-08-29 06:38:27 UTC
Yes, we really need this option! Besides Chinese characters, even English on output panel is rather ugly.
Comment 4 jrojcek 2007-08-29 12:17:05 UTC
The font size and family used in menus, dialogs, trees, tables, etc. should be selected based on font used by the operating system. The output window should 
use the default fixed font defined in the operating system. So no option should be needed.

The goal is to use the same font the user is used to from the operating system environment.
Comment 5 Ken Frank 2007-08-29 16:36:14 UTC
not 100% sure but I think its not the os that decides the ide font, but the jdk.  that is,
the definition of which logical jdk font to use is coded into the ide.  then the jdk font props
files have hardcoded physical font family names, per platform/os, that map to these logical names.


And the goal here is not to force user to change the jdk font props file at all; but to provide
out of the box solution for users.

ken.frank@sun.com
Comment 6 rehte 2007-09-03 11:14:53 UTC
Ken,
How's everything going on?
I got lots of feedback from Chinese developers from the forum that they desired this feature very much. Yet a lot of
them don't have the account to come here comment. And many of them are in fact students, which cannot even access
netbeans site because they are limited  to Chinese educational net.
In fact, I think this is not only a feature that Chinese developers want, but also a feature all netbeans users want.
And in fact, I think it a design defect, since you simply have no place to change the overall font!
Comment 7 Ken Frank 2007-09-03 17:44:08 UTC
Rehte,

thanks for providing the additional feedback.  I think discussion now is how the option
would be presented; command line or ui.  For nb6, it might need to be command line
since we are past the new feature time.  We realize ui way could be the best in the long term.

Also, step 1 might be providing an option for chinese users that hardcodes it to the
DialogInput, or at least having some error checking so that the provided argument is
determined to be a logical jdk font and not a physical one on machine.

and I think 113691 also will be needed for editor; there is a way to change the editor
global font but it requires a few steps in options window.

ken.frank@sun.com
Comment 8 idandego 2007-09-05 09:28:45 UTC
I think the default ide font ( means font of menu ,dialog etc) is controlled by JRE/JDK , so basicly  what we can do is
to change JDK font setting or override the setting when netbeans starts. I would say that I prefer the first one because
this issue is not only about netbeans, but also on all swing based GUI program. but to change the default font setting
of JRE, I think we need communication with JDK develop group.
Comment 9 lamyseba 2007-10-19 18:28:20 UTC
*** Issue 101740 has been marked as a duplicate of this issue. ***
Comment 10 Rebecca Liu 2007-10-26 06:20:10 UTC
I think it is true that nb6.0 IDE starts to use OS default font. You can check the attached image nb60_vs_window.PNG.
You can see NB6.0 IDE font is exactly the same with common Windows software's font.

But 5.5 IDE is different. The font of 5.5 IDE is decided by JDK I guess. You can see the difference from attached image
ide.PNG. In IDE 5.5, with default fontsize 11, the characters look too small; with fontsize 12, the font looks ok but
still different with OS font. That font is selected by JDK.

So I would suggest we wait until NB6.0 is released. After release we can ask users again for their opinions on the font
issues. I think most Chinese users will accept current NB6.0 IDE font.
Comment 11 Rebecca Liu 2007-10-26 06:21:56 UTC
Created attachment 51747 [details]
nb60_vs_windows image
Comment 12 Rebecca Liu 2007-10-26 06:23:30 UTC
Created attachment 51748 [details]
ide image
Comment 13 David Simonek 2007-11-01 21:43:05 UTC
*** Issue 116676 has been marked as a duplicate of this issue. ***
Comment 14 Ken Frank 2008-01-11 05:41:30 UTC
this rfe includes about fontsize also, just to be clear.

ken.frank@sun.com
Comment 15 Ken Frank 2008-01-11 05:45:17 UTC
*** Issue 125083 has been marked as a duplicate of this issue. ***
Comment 16 Ken Frank 2008-01-15 21:35:02 UTC
can this be done for 6.1 release ? I realize its a short release
time but it seems we have input from external users about it.

ken.frank@sun.com
Comment 17 barty 2008-02-09 19:47:23 UTC
I'm not a Chinese user, but I'd also like to be able to change the font used in the IDE because I have 20/100 vision.

I realize I can change the font size using --fontsize parameter.  However, making the font bigger doesn't necessarily make it easier to see because the font used is 
so fine (it's not so much the size that gives me trouble, it's the thinness of the lines).  I believe NB is using the default dialog font set by the OS, which looks to be 
Tahoma under Windows XP.  MSFT has hardcoded this and there's no way to change it.

With things like variable watches, it's important to be able to see the font at a glance rather than having to lean close to the monitor and stare at it.

Having a --fontface parameter would help me a great deal.
Comment 18 lamyseba 2008-02-10 11:33:41 UTC
Seems like an important topic: lots of comments and lots of duplicates for this bug.
Any idea if it will be resolved?
Comment 19 Ken Frank 2008-02-10 17:29:58 UTC
to those on interest list from netbeans community, please vote for this issue if you
feel its something that should be done and let others who want to see this implemented
to know about that.

and as comment from barty mentions, this is not an i18n only situation or a situation
that relates to only users who run in other locales thus am adding some other applicable
keywords.


As to solving it for font names, I think implementation could allow, like for editor,
font names that are system/os font names as well as jdk logical font names.

ken.frank@sun.com
Comment 20 Tomas Danek 2008-09-23 13:26:59 UTC
as far as i understand this issue, it's about to implement UI for command line switch for --fontsize CLI switch
(http://wiki.netbeans.org/FaqFontSize). Passing to core/options for further evaluation.
Comment 21 Ken Frank 2008-09-23 16:00:03 UTC
to clarify, this is not about adding to what --fontsize option does,
but a separate startup option and/or a setting in options window.

ken.frank@sun.com
Comment 22 bobw 2010-06-09 18:16:49 UTC
We're now just about to 6.9 and this is still open... is this going to happen? International issues not withstanding, I'd *really* like to be able to control the non-editor fonts on my English OS X installation - the current font is just way, way too big, especially in places like the Navigator and Projects windows, where a ton of screen space is wasted.
Comment 23 Geertjan Wielenga 2010-06-09 18:22:05 UTC
You can use --fontsize to change the size of the font. In the netbeans.conf file which is in the 'etc' folder of your NetBeans IDE installation.
Comment 24 bobw 2010-06-11 21:10:25 UTC
Using --fontsize is a good workaround to help out with the primary pain points like the Project window. However, it's definitely not a good solution to this problem for the following reasons:

- It affects nearly all  text in the IDE, including control labels and such. These things should be controlled by the OS, but content text (like in Project or Navigator) should be user-adjustable.

- It's done in the app, which means it will be the same across users. And, it's tied to the specific version of NB.

- One must restart the IDE for the change to take affect. Combined with having to dig into a deeply nested config file, it's not at all user-friendly to tweak this setting.

All that said, the pain of the bigger font in a few key places is enough for me to go with this workaround. I'd still like to see a real solution, however.
Comment 25 twolf2919 2010-06-11 21:23:45 UTC
I totally agree with bobw - setting --fontsize is a workaround at best (and if I remember correctly, it doesn't even work with GTK look & feel).

There really needs to be some level of customization of the non-editor fonts.  The ultimate solution would be for the IDE to let me right-click on any IDE window (e.g. the project window) and let me set its font, background, and foreground colors.  If this was done, not only would I be able to save real estate where *I* want, it would also let me save my eyes by finally letting me put a light-on-dark background on the remaining windows in my IDE (the editor already lets me do this, why not the other windows?)
Comment 26 Jaromir Uhrik 2010-11-01 09:12:15 UTC
We have the possibility to change fonts for editor. It should be possible to change the font for any other component while IDE is running. Of course for editor it makes sense to have separate settings and all other components should probably share just one setting for the fonts setup.
Comment 27 lostgodguan 2010-12-20 12:17:26 UTC
OS: windows vista
IDE:Netbeans6.7.1
Font:himalaya.ttf (Tibetan's fonts, it's Unicode)
Letters on the vertical position of overlap(Accessories shown in the picture).
Eclipse have not the problem,but I hope use Netbeans forever.
Please solve the problem!
Comment 28 lostgodguan 2010-12-20 12:20:39 UTC
OS: windows vista
IDE:Netbeans6.7.1
Font:himalaya.ttf (Tibetan's fonts, it's Unicode)
Letters on the vertical position of overlap(Accessories shown in the picture).
Eclipse have not the problem,but I hope use Netbeans forever.
Please solve the problem!
Comment 29 lostgodguan 2010-12-20 12:39:51 UTC
OS: windows vista
IDE:Netbeans6.7.1
Font:himalaya.ttf (Tibetan's fonts, it's Unicode)
Letters on the vertical position of overlap(Accessories shown in the picture).
Eclipse have not the problem,but I hope use Netbeans forever.
Please solve the problem!


By use of this website, you agree to the NetBeans Policies and Terms of Use. © 2012, Oracle Corporation and/or its affiliates. Sponsored by Oracle logo